# -*- coding: utf-8 -*-
from setuphelpers import *
import json

def update_package():
    print("Downloading/Updating package content from upstream binary sources")

    # Initializing variables
    bin_name_string = "klavaro-%s-win-setup.exe"
    proxies = get_proxies()
    app_name = control.name
    git_repo = "klavaro"
    url_api = "https://sourceforge.net/projects/%s/best_release.json" % git_repo

    # Getting latest version from official website
    print("API used is: " + url_api)
    json_load = json.loads(wgets(url_api, proxies=proxies))
    latest_bin = json_load["platform_releases"]["windows"]["filename"].split("/")[-1]
    version = latest_bin.split("-")[1]
    url_dl = "https://sourceforge.net/projects/%s/files/%s/download" % (git_repo, latest_bin)

    print("Latest %s version is: %s" % (app_name, version))
    print("Download url is: %s" % url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(url_dl, latest_bin, proxies=proxies)

        # Checking version from file
        version_from_file = get_version_from_binary(latest_bin)
        if version != version_from_file:
            os.rename(latest_bin, bin_name_string % version_from_file)
            version = version_from_file

        # Changing version of the package
        control.version = "%s-%s" % (version, int(control.version.split("-")[-1]) + 1)
        control.save_control_to_wapt()
        print("Changing package version to: %s in WAPT\\control" % control.version)

    # Deleting outdated binaries
    remove_outdated_binaries(version)